# coding: utf-8

"""
    Devdraft AI Payment & Business Management API

     A comprehensive payment processing and business management API that enables seamless integration of cryptocurrency and traditional payment methods.       # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from devdraft_ai_sdk.api_client import ApiClient


class LiquidationAddressesApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def liquidation_address_controller_create_liquidation_address(self, body, customer_id, **kwargs):  # noqa: E501
        """Create a new liquidation address for a customer  # noqa: E501

               Create a new liquidation address for a customer. Liquidation addresses allow        customers to automatically liquidate cryptocurrency holdings to fiat or other        stablecoins based on configured parameters.        **Required fields:**       - chain: Blockchain network (ethereum, polygon, arbitrum, base)       - currency: Stablecoin currency (usdc, eurc, dai, pyusd, usdt)       - address: Valid blockchain address        **At least one destination must be specified:**       - external_account_id: External bank account       - prefunded_account_id: Developer's prefunded account       - bridge_wallet_id: Bridge wallet       - destination_address: Crypto wallet address        **Payment Rails:**       Different payment rails have different requirements:       - ACH: Requires external_account_id, supports destination_ach_reference       - SEPA: Requires external_account_id, supports destination_sepa_reference       - Wire: Requires external_account_id, supports destination_wire_message       - Crypto: Requires destination_address, supports destination_blockchain_memo       # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.liquidation_address_controller_create_liquidation_address(body, customer_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateLiquidationAddressDto body: (required)
        :param str customer_id: Unique identifier for the customer (required)
        :return: LiquidationAddressResponseDto
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.liquidation_address_controller_create_liquidation_address_with_http_info(body, customer_id, **kwargs)  # noqa: E501
        else:
            (data) = self.liquidation_address_controller_create_liquidation_address_with_http_info(body, customer_id, **kwargs)  # noqa: E501
            return data

    def liquidation_address_controller_create_liquidation_address_with_http_info(self, body, customer_id, **kwargs):  # noqa: E501
        """Create a new liquidation address for a customer  # noqa: E501

               Create a new liquidation address for a customer. Liquidation addresses allow        customers to automatically liquidate cryptocurrency holdings to fiat or other        stablecoins based on configured parameters.        **Required fields:**       - chain: Blockchain network (ethereum, polygon, arbitrum, base)       - currency: Stablecoin currency (usdc, eurc, dai, pyusd, usdt)       - address: Valid blockchain address        **At least one destination must be specified:**       - external_account_id: External bank account       - prefunded_account_id: Developer's prefunded account       - bridge_wallet_id: Bridge wallet       - destination_address: Crypto wallet address        **Payment Rails:**       Different payment rails have different requirements:       - ACH: Requires external_account_id, supports destination_ach_reference       - SEPA: Requires external_account_id, supports destination_sepa_reference       - Wire: Requires external_account_id, supports destination_wire_message       - Crypto: Requires destination_address, supports destination_blockchain_memo       # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.liquidation_address_controller_create_liquidation_address_with_http_info(body, customer_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CreateLiquidationAddressDto body: (required)
        :param str customer_id: Unique identifier for the customer (required)
        :return: LiquidationAddressResponseDto
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'customer_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method liquidation_address_controller_create_liquidation_address" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `liquidation_address_controller_create_liquidation_address`")  # noqa: E501
        # verify the required parameter 'customer_id' is set
        if ('customer_id' not in params or
                params['customer_id'] is None):
            raise ValueError("Missing the required parameter `customer_id` when calling `liquidation_address_controller_create_liquidation_address`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'customer_id' in params:
            path_params['customerId'] = params['customer_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/api/v0/customers/{customerId}/liquidation_addresses', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='LiquidationAddressResponseDto',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def liquidation_address_controller_get_liquidation_address(self, customer_id, liquidation_address_id, **kwargs):  # noqa: E501
        """Get a specific liquidation address  # noqa: E501

        Retrieve a specific liquidation address by its ID for a given customer.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.liquidation_address_controller_get_liquidation_address(customer_id, liquidation_address_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str customer_id: Unique identifier for the customer (required)
        :param str liquidation_address_id: Unique identifier for the liquidation address (required)
        :return: LiquidationAddressResponseDto
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.liquidation_address_controller_get_liquidation_address_with_http_info(customer_id, liquidation_address_id, **kwargs)  # noqa: E501
        else:
            (data) = self.liquidation_address_controller_get_liquidation_address_with_http_info(customer_id, liquidation_address_id, **kwargs)  # noqa: E501
            return data

    def liquidation_address_controller_get_liquidation_address_with_http_info(self, customer_id, liquidation_address_id, **kwargs):  # noqa: E501
        """Get a specific liquidation address  # noqa: E501

        Retrieve a specific liquidation address by its ID for a given customer.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.liquidation_address_controller_get_liquidation_address_with_http_info(customer_id, liquidation_address_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str customer_id: Unique identifier for the customer (required)
        :param str liquidation_address_id: Unique identifier for the liquidation address (required)
        :return: LiquidationAddressResponseDto
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['customer_id', 'liquidation_address_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method liquidation_address_controller_get_liquidation_address" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'customer_id' is set
        if ('customer_id' not in params or
                params['customer_id'] is None):
            raise ValueError("Missing the required parameter `customer_id` when calling `liquidation_address_controller_get_liquidation_address`")  # noqa: E501
        # verify the required parameter 'liquidation_address_id' is set
        if ('liquidation_address_id' not in params or
                params['liquidation_address_id'] is None):
            raise ValueError("Missing the required parameter `liquidation_address_id` when calling `liquidation_address_controller_get_liquidation_address`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'customer_id' in params:
            path_params['customerId'] = params['customer_id']  # noqa: E501
        if 'liquidation_address_id' in params:
            path_params['liquidationAddressId'] = params['liquidation_address_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/api/v0/customers/{customerId}/liquidation_addresses/{liquidationAddressId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='LiquidationAddressResponseDto',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def liquidation_address_controller_get_liquidation_addresses(self, customer_id, **kwargs):  # noqa: E501
        """Get all liquidation addresses for a customer  # noqa: E501

        Retrieve all liquidation addresses associated with a specific customer.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.liquidation_address_controller_get_liquidation_addresses(customer_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str customer_id: Unique identifier for the customer (required)
        :return: list[LiquidationAddressResponseDto]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.liquidation_address_controller_get_liquidation_addresses_with_http_info(customer_id, **kwargs)  # noqa: E501
        else:
            (data) = self.liquidation_address_controller_get_liquidation_addresses_with_http_info(customer_id, **kwargs)  # noqa: E501
            return data

    def liquidation_address_controller_get_liquidation_addresses_with_http_info(self, customer_id, **kwargs):  # noqa: E501
        """Get all liquidation addresses for a customer  # noqa: E501

        Retrieve all liquidation addresses associated with a specific customer.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.liquidation_address_controller_get_liquidation_addresses_with_http_info(customer_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str customer_id: Unique identifier for the customer (required)
        :return: list[LiquidationAddressResponseDto]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['customer_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method liquidation_address_controller_get_liquidation_addresses" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'customer_id' is set
        if ('customer_id' not in params or
                params['customer_id'] is None):
            raise ValueError("Missing the required parameter `customer_id` when calling `liquidation_address_controller_get_liquidation_addresses`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'customer_id' in params:
            path_params['customerId'] = params['customer_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/api/v0/customers/{customerId}/liquidation_addresses', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[LiquidationAddressResponseDto]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
