# coding: utf-8

"""
    Devdraft AI Payment & Business Management API

     A comprehensive payment processing and business management API that enables seamless integration of cryptocurrency and traditional payment methods.       # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CreateStablePaymentIntentDto(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'source_currency': 'AllOfCreateStablePaymentIntentDtoSourceCurrency',
        'source_network': 'AllOfCreateStablePaymentIntentDtoSourceNetwork',
        'destination_currency': 'AllOfCreateStablePaymentIntentDtoDestinationCurrency',
        'destination_network': 'AllOfCreateStablePaymentIntentDtoDestinationNetwork',
        'destination_address': 'str',
        'amount': 'str',
        'customer_first_name': 'str',
        'customer_last_name': 'str',
        'customer_email': 'str',
        'customer_address': 'str',
        'customer_country': 'str',
        'customer_country_iso': 'str',
        'customer_province': 'str',
        'customer_province_iso': 'str',
        'phone_number': 'str'
    }

    attribute_map = {
        'source_currency': 'sourceCurrency',
        'source_network': 'sourceNetwork',
        'destination_currency': 'destinationCurrency',
        'destination_network': 'destinationNetwork',
        'destination_address': 'destinationAddress',
        'amount': 'amount',
        'customer_first_name': 'customer_first_name',
        'customer_last_name': 'customer_last_name',
        'customer_email': 'customer_email',
        'customer_address': 'customer_address',
        'customer_country': 'customer_country',
        'customer_country_iso': 'customer_countryISO',
        'customer_province': 'customer_province',
        'customer_province_iso': 'customer_provinceISO',
        'phone_number': 'phoneNumber'
    }

    def __init__(self, source_currency=None, source_network=None, destination_currency=None, destination_network=None, destination_address=None, amount=None, customer_first_name=None, customer_last_name=None, customer_email=None, customer_address=None, customer_country=None, customer_country_iso=None, customer_province=None, customer_province_iso=None, phone_number=None):  # noqa: E501
        """CreateStablePaymentIntentDto - a model defined in Swagger"""  # noqa: E501
        self._source_currency = None
        self._source_network = None
        self._destination_currency = None
        self._destination_network = None
        self._destination_address = None
        self._amount = None
        self._customer_first_name = None
        self._customer_last_name = None
        self._customer_email = None
        self._customer_address = None
        self._customer_country = None
        self._customer_country_iso = None
        self._customer_province = None
        self._customer_province_iso = None
        self._phone_number = None
        self.discriminator = None
        self.source_currency = source_currency
        self.source_network = source_network
        if destination_currency is not None:
            self.destination_currency = destination_currency
        self.destination_network = destination_network
        if destination_address is not None:
            self.destination_address = destination_address
        if amount is not None:
            self.amount = amount
        if customer_first_name is not None:
            self.customer_first_name = customer_first_name
        if customer_last_name is not None:
            self.customer_last_name = customer_last_name
        if customer_email is not None:
            self.customer_email = customer_email
        if customer_address is not None:
            self.customer_address = customer_address
        if customer_country is not None:
            self.customer_country = customer_country
        if customer_country_iso is not None:
            self.customer_country_iso = customer_country_iso
        if customer_province is not None:
            self.customer_province = customer_province
        if customer_province_iso is not None:
            self.customer_province_iso = customer_province_iso
        if phone_number is not None:
            self.phone_number = phone_number

    @property
    def source_currency(self):
        """Gets the source_currency of this CreateStablePaymentIntentDto.  # noqa: E501

        The stablecoin currency to convert FROM. This is the currency the customer will pay with.  # noqa: E501

        :return: The source_currency of this CreateStablePaymentIntentDto.  # noqa: E501
        :rtype: AllOfCreateStablePaymentIntentDtoSourceCurrency
        """
        return self._source_currency

    @source_currency.setter
    def source_currency(self, source_currency):
        """Sets the source_currency of this CreateStablePaymentIntentDto.

        The stablecoin currency to convert FROM. This is the currency the customer will pay with.  # noqa: E501

        :param source_currency: The source_currency of this CreateStablePaymentIntentDto.  # noqa: E501
        :type: AllOfCreateStablePaymentIntentDtoSourceCurrency
        """
        if source_currency is None:
            raise ValueError("Invalid value for `source_currency`, must not be `None`")  # noqa: E501

        self._source_currency = source_currency

    @property
    def source_network(self):
        """Gets the source_network of this CreateStablePaymentIntentDto.  # noqa: E501

        The blockchain network where the source currency resides. Determines gas fees and transaction speed.  # noqa: E501

        :return: The source_network of this CreateStablePaymentIntentDto.  # noqa: E501
        :rtype: AllOfCreateStablePaymentIntentDtoSourceNetwork
        """
        return self._source_network

    @source_network.setter
    def source_network(self, source_network):
        """Sets the source_network of this CreateStablePaymentIntentDto.

        The blockchain network where the source currency resides. Determines gas fees and transaction speed.  # noqa: E501

        :param source_network: The source_network of this CreateStablePaymentIntentDto.  # noqa: E501
        :type: AllOfCreateStablePaymentIntentDtoSourceNetwork
        """
        if source_network is None:
            raise ValueError("Invalid value for `source_network`, must not be `None`")  # noqa: E501

        self._source_network = source_network

    @property
    def destination_currency(self):
        """Gets the destination_currency of this CreateStablePaymentIntentDto.  # noqa: E501

        The stablecoin currency to convert TO. If omitted, defaults to the same as source currency (cross-chain transfer).  # noqa: E501

        :return: The destination_currency of this CreateStablePaymentIntentDto.  # noqa: E501
        :rtype: AllOfCreateStablePaymentIntentDtoDestinationCurrency
        """
        return self._destination_currency

    @destination_currency.setter
    def destination_currency(self, destination_currency):
        """Sets the destination_currency of this CreateStablePaymentIntentDto.

        The stablecoin currency to convert TO. If omitted, defaults to the same as source currency (cross-chain transfer).  # noqa: E501

        :param destination_currency: The destination_currency of this CreateStablePaymentIntentDto.  # noqa: E501
        :type: AllOfCreateStablePaymentIntentDtoDestinationCurrency
        """

        self._destination_currency = destination_currency

    @property
    def destination_network(self):
        """Gets the destination_network of this CreateStablePaymentIntentDto.  # noqa: E501

        The blockchain network where the converted currency will be delivered. Must support the destination currency.  # noqa: E501

        :return: The destination_network of this CreateStablePaymentIntentDto.  # noqa: E501
        :rtype: AllOfCreateStablePaymentIntentDtoDestinationNetwork
        """
        return self._destination_network

    @destination_network.setter
    def destination_network(self, destination_network):
        """Sets the destination_network of this CreateStablePaymentIntentDto.

        The blockchain network where the converted currency will be delivered. Must support the destination currency.  # noqa: E501

        :param destination_network: The destination_network of this CreateStablePaymentIntentDto.  # noqa: E501
        :type: AllOfCreateStablePaymentIntentDtoDestinationNetwork
        """
        if destination_network is None:
            raise ValueError("Invalid value for `destination_network`, must not be `None`")  # noqa: E501

        self._destination_network = destination_network

    @property
    def destination_address(self):
        """Gets the destination_address of this CreateStablePaymentIntentDto.  # noqa: E501

        The wallet address where converted funds will be sent. Supports Ethereum (0x...) and Solana address formats.  # noqa: E501

        :return: The destination_address of this CreateStablePaymentIntentDto.  # noqa: E501
        :rtype: str
        """
        return self._destination_address

    @destination_address.setter
    def destination_address(self, destination_address):
        """Sets the destination_address of this CreateStablePaymentIntentDto.

        The wallet address where converted funds will be sent. Supports Ethereum (0x...) and Solana address formats.  # noqa: E501

        :param destination_address: The destination_address of this CreateStablePaymentIntentDto.  # noqa: E501
        :type: str
        """

        self._destination_address = destination_address

    @property
    def amount(self):
        """Gets the amount of this CreateStablePaymentIntentDto.  # noqa: E501

        Payment amount in the source currency. Omit for flexible amount payments where users specify the amount during checkout.  # noqa: E501

        :return: The amount of this CreateStablePaymentIntentDto.  # noqa: E501
        :rtype: str
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this CreateStablePaymentIntentDto.

        Payment amount in the source currency. Omit for flexible amount payments where users specify the amount during checkout.  # noqa: E501

        :param amount: The amount of this CreateStablePaymentIntentDto.  # noqa: E501
        :type: str
        """

        self._amount = amount

    @property
    def customer_first_name(self):
        """Gets the customer_first_name of this CreateStablePaymentIntentDto.  # noqa: E501

        Customer's first name. Used for transaction records and compliance. Required for amounts over $1000.  # noqa: E501

        :return: The customer_first_name of this CreateStablePaymentIntentDto.  # noqa: E501
        :rtype: str
        """
        return self._customer_first_name

    @customer_first_name.setter
    def customer_first_name(self, customer_first_name):
        """Sets the customer_first_name of this CreateStablePaymentIntentDto.

        Customer's first name. Used for transaction records and compliance. Required for amounts over $1000.  # noqa: E501

        :param customer_first_name: The customer_first_name of this CreateStablePaymentIntentDto.  # noqa: E501
        :type: str
        """

        self._customer_first_name = customer_first_name

    @property
    def customer_last_name(self):
        """Gets the customer_last_name of this CreateStablePaymentIntentDto.  # noqa: E501

        Customer's last name. Used for transaction records and compliance. Required for amounts over $1000.  # noqa: E501

        :return: The customer_last_name of this CreateStablePaymentIntentDto.  # noqa: E501
        :rtype: str
        """
        return self._customer_last_name

    @customer_last_name.setter
    def customer_last_name(self, customer_last_name):
        """Sets the customer_last_name of this CreateStablePaymentIntentDto.

        Customer's last name. Used for transaction records and compliance. Required for amounts over $1000.  # noqa: E501

        :param customer_last_name: The customer_last_name of this CreateStablePaymentIntentDto.  # noqa: E501
        :type: str
        """

        self._customer_last_name = customer_last_name

    @property
    def customer_email(self):
        """Gets the customer_email of this CreateStablePaymentIntentDto.  # noqa: E501

        Customer's email address. Used for transaction notifications and receipts. Highly recommended for all transactions.  # noqa: E501

        :return: The customer_email of this CreateStablePaymentIntentDto.  # noqa: E501
        :rtype: str
        """
        return self._customer_email

    @customer_email.setter
    def customer_email(self, customer_email):
        """Sets the customer_email of this CreateStablePaymentIntentDto.

        Customer's email address. Used for transaction notifications and receipts. Highly recommended for all transactions.  # noqa: E501

        :param customer_email: The customer_email of this CreateStablePaymentIntentDto.  # noqa: E501
        :type: str
        """

        self._customer_email = customer_email

    @property
    def customer_address(self):
        """Gets the customer_address of this CreateStablePaymentIntentDto.  # noqa: E501

        Customer's full address. Required for compliance in certain jurisdictions and high-value transactions.  # noqa: E501

        :return: The customer_address of this CreateStablePaymentIntentDto.  # noqa: E501
        :rtype: str
        """
        return self._customer_address

    @customer_address.setter
    def customer_address(self, customer_address):
        """Sets the customer_address of this CreateStablePaymentIntentDto.

        Customer's full address. Required for compliance in certain jurisdictions and high-value transactions.  # noqa: E501

        :param customer_address: The customer_address of this CreateStablePaymentIntentDto.  # noqa: E501
        :type: str
        """

        self._customer_address = customer_address

    @property
    def customer_country(self):
        """Gets the customer_country of this CreateStablePaymentIntentDto.  # noqa: E501

        Customer's country of residence. Used for compliance and tax reporting.  # noqa: E501

        :return: The customer_country of this CreateStablePaymentIntentDto.  # noqa: E501
        :rtype: str
        """
        return self._customer_country

    @customer_country.setter
    def customer_country(self, customer_country):
        """Sets the customer_country of this CreateStablePaymentIntentDto.

        Customer's country of residence. Used for compliance and tax reporting.  # noqa: E501

        :param customer_country: The customer_country of this CreateStablePaymentIntentDto.  # noqa: E501
        :type: str
        """

        self._customer_country = customer_country

    @property
    def customer_country_iso(self):
        """Gets the customer_country_iso of this CreateStablePaymentIntentDto.  # noqa: E501

        Customer's country ISO 3166-1 alpha-2 code. Used for automated compliance checks.  # noqa: E501

        :return: The customer_country_iso of this CreateStablePaymentIntentDto.  # noqa: E501
        :rtype: str
        """
        return self._customer_country_iso

    @customer_country_iso.setter
    def customer_country_iso(self, customer_country_iso):
        """Sets the customer_country_iso of this CreateStablePaymentIntentDto.

        Customer's country ISO 3166-1 alpha-2 code. Used for automated compliance checks.  # noqa: E501

        :param customer_country_iso: The customer_country_iso of this CreateStablePaymentIntentDto.  # noqa: E501
        :type: str
        """

        self._customer_country_iso = customer_country_iso

    @property
    def customer_province(self):
        """Gets the customer_province of this CreateStablePaymentIntentDto.  # noqa: E501

        Customer's state or province. Required for US and Canadian customers.  # noqa: E501

        :return: The customer_province of this CreateStablePaymentIntentDto.  # noqa: E501
        :rtype: str
        """
        return self._customer_province

    @customer_province.setter
    def customer_province(self, customer_province):
        """Sets the customer_province of this CreateStablePaymentIntentDto.

        Customer's state or province. Required for US and Canadian customers.  # noqa: E501

        :param customer_province: The customer_province of this CreateStablePaymentIntentDto.  # noqa: E501
        :type: str
        """

        self._customer_province = customer_province

    @property
    def customer_province_iso(self):
        """Gets the customer_province_iso of this CreateStablePaymentIntentDto.  # noqa: E501

        Customer's state or province ISO code. Used for automated tax calculations.  # noqa: E501

        :return: The customer_province_iso of this CreateStablePaymentIntentDto.  # noqa: E501
        :rtype: str
        """
        return self._customer_province_iso

    @customer_province_iso.setter
    def customer_province_iso(self, customer_province_iso):
        """Sets the customer_province_iso of this CreateStablePaymentIntentDto.

        Customer's state or province ISO code. Used for automated tax calculations.  # noqa: E501

        :param customer_province_iso: The customer_province_iso of this CreateStablePaymentIntentDto.  # noqa: E501
        :type: str
        """

        self._customer_province_iso = customer_province_iso

    @property
    def phone_number(self):
        """Gets the phone_number of this CreateStablePaymentIntentDto.  # noqa: E501

        Customer's phone number with country code. Used for SMS notifications and verification.  # noqa: E501

        :return: The phone_number of this CreateStablePaymentIntentDto.  # noqa: E501
        :rtype: str
        """
        return self._phone_number

    @phone_number.setter
    def phone_number(self, phone_number):
        """Sets the phone_number of this CreateStablePaymentIntentDto.

        Customer's phone number with country code. Used for SMS notifications and verification.  # noqa: E501

        :param phone_number: The phone_number of this CreateStablePaymentIntentDto.  # noqa: E501
        :type: str
        """

        self._phone_number = phone_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateStablePaymentIntentDto, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateStablePaymentIntentDto):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
