# coding: utf-8

"""
    Devdraft AI Payment & Business Management API

     A comprehensive payment processing and business management API that enables seamless integration of cryptocurrency and traditional payment methods.       # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class UpdateWebhookDto(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'url': 'str',
        'is_active': 'bool',
        'signing_secret': 'str',
        'encrypted': 'bool'
    }

    attribute_map = {
        'name': 'name',
        'url': 'url',
        'is_active': 'isActive',
        'signing_secret': 'signing_secret',
        'encrypted': 'encrypted'
    }

    def __init__(self, name=None, url=None, is_active=True, signing_secret=None, encrypted=False):  # noqa: E501
        """UpdateWebhookDto - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._url = None
        self._is_active = None
        self._signing_secret = None
        self._encrypted = None
        self.discriminator = None
        if name is not None:
            self.name = name
        if url is not None:
            self.url = url
        if is_active is not None:
            self.is_active = is_active
        if signing_secret is not None:
            self.signing_secret = signing_secret
        if encrypted is not None:
            self.encrypted = encrypted

    @property
    def name(self):
        """Gets the name of this UpdateWebhookDto.  # noqa: E501

        Name of the webhook for identification purposes  # noqa: E501

        :return: The name of this UpdateWebhookDto.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this UpdateWebhookDto.

        Name of the webhook for identification purposes  # noqa: E501

        :param name: The name of this UpdateWebhookDto.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def url(self):
        """Gets the url of this UpdateWebhookDto.  # noqa: E501

        URL where webhook events will be sent  # noqa: E501

        :return: The url of this UpdateWebhookDto.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this UpdateWebhookDto.

        URL where webhook events will be sent  # noqa: E501

        :param url: The url of this UpdateWebhookDto.  # noqa: E501
        :type: str
        """

        self._url = url

    @property
    def is_active(self):
        """Gets the is_active of this UpdateWebhookDto.  # noqa: E501

        Whether the webhook is active and will receive events  # noqa: E501

        :return: The is_active of this UpdateWebhookDto.  # noqa: E501
        :rtype: bool
        """
        return self._is_active

    @is_active.setter
    def is_active(self, is_active):
        """Sets the is_active of this UpdateWebhookDto.

        Whether the webhook is active and will receive events  # noqa: E501

        :param is_active: The is_active of this UpdateWebhookDto.  # noqa: E501
        :type: bool
        """

        self._is_active = is_active

    @property
    def signing_secret(self):
        """Gets the signing_secret of this UpdateWebhookDto.  # noqa: E501

        Secret key used to sign webhook payloads for verification  # noqa: E501

        :return: The signing_secret of this UpdateWebhookDto.  # noqa: E501
        :rtype: str
        """
        return self._signing_secret

    @signing_secret.setter
    def signing_secret(self, signing_secret):
        """Sets the signing_secret of this UpdateWebhookDto.

        Secret key used to sign webhook payloads for verification  # noqa: E501

        :param signing_secret: The signing_secret of this UpdateWebhookDto.  # noqa: E501
        :type: str
        """

        self._signing_secret = signing_secret

    @property
    def encrypted(self):
        """Gets the encrypted of this UpdateWebhookDto.  # noqa: E501

        Whether webhook payloads should be encrypted  # noqa: E501

        :return: The encrypted of this UpdateWebhookDto.  # noqa: E501
        :rtype: bool
        """
        return self._encrypted

    @encrypted.setter
    def encrypted(self, encrypted):
        """Sets the encrypted of this UpdateWebhookDto.

        Whether webhook payloads should be encrypted  # noqa: E501

        :param encrypted: The encrypted of this UpdateWebhookDto.  # noqa: E501
        :type: bool
        """

        self._encrypted = encrypted

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateWebhookDto, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateWebhookDto):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
